//"dokframe.sci","Dokument sprzeday - ramki","\Dokumenty\Sprzeda\",0,1.0.7,SYSTEM
////////////////////////////
// Dokument sprzeday - ramki
// dokframe.sci
//////////////////////////
#include "Wydruki - include"
#define R_PIECZEC 1
#define R_NAZWADOK 2
#define R_DATAIMIEJSCE 3
#define R_NUMER 4
#define R_NAPIS 5
#define R_DATAOKRES 6
#define R_BITMAP 7
#define R_SPRZEDAWCA 8
#define R_NABYWCA 9
#define R_DANEPLATNOSCI 10
#define R_ODBIORCA 11
#define R_DOZAPLATYW 12
#define R_DOZAPLATYN 18
#define R_ZAPLACONO 13
#define R_UPOWAZW 14
#define R_UPOWAZN 15
#define R_NRDATAKORYG 16
#define R_TERMINREAL 19
#define R_ZALOTRZYMANO 20
#define R_ZALNIEOBEJETE 21
#define R_DOKNIEFAKT 22
#define R_WTYMVAT 23

#define R_WYSTAWCA 24
#define R_DANEPLATNOSCI_WYST 25
#define R_NRDATAKORYG_EXTRA  26


#include "Formatowanie ramek nagwka"
#ifndef KOREKTY
	xDocType=xDocument.Charakter
#else
	int bPrzelew
	xFormaPl = xDocument.FormaPl
#endif

#include "Dokument sprzeday - ramki - definicje"

if xFormaPl.Typ==1 then bPrzelew=1

record rPrezentowane
	float netto
	float vat
	float brutto
	float wwalucie
	float wwaluciePodlega
endrec


rPrezentowane rWartosci

#ifndef PKURS_DEFINED
#define PKURS_DEFINED
Int PKurs, PKursDoch
#endif //PKURS_DEFINED

int sub DrukujKontakt(string t1, string t2, string fx, string eml, int flatmode)
	if flatmode then
		if t1 then
			SetFont("tekst") : print "Telefon: "
			SetFont(nb)	:		print t1
			if t2 then print ", ";t2
			flatmode = 0
		endif
		if fx then
			if !flatmode then print "   "
			SetFont("tekst") : print "Fax: "
			SetFont(nb) : print fx;
			flatmode=0
		endif
		if eml then
			if !flatmode then print "     "
			SetFont("tekst") : print "E-mail: "
			SetFont(nb) : print eml
		endif
		exit
	endif
	if t1 then
		tabela #tblIn
			kolumna 1
			SetFont("tekst") : print "Telefon:"
			kolumna 2
			SetFont(nb)
			print t1
			if t2 then print ", ";t2
			if fx then
				SetFont("tekst")
				print "   Fax: "
				SetFont(nb)
				print fx
			endif
		koniec
	endif
	if fx && !t1 then
		tabela #tblIn
			kolumna 1
			SetFont ( "tekst" ) : print "Fax:"
			kolumna 2
			SetFont ( nb ) : print fx;
		koniec
	endif
	if eml then
		tabela #tblIn
			kolumna 1
			SetFont ( "tekst" ) : print "E-mail:"
			kolumna 2
			SetFont ( nb ) : print eml
		koniec
	endif
endsub


int sub FRDrawContent( int FRszer, int FRwys , int FRid )
int i
string sTmp
int daneX
	if FRid==R_PIECZEC  then
		if !bmpStamp then
			SetStyl ( sc )
			print at #X,FRwys-40;"piecz firmy"
		else
			bmp = Bitmap FRszer,FRwys,sBitmap
			Bitmap #bmp
		endif
	endif
	if FRid==R_NAZWADOK then
		SetStyl ( bbc )
		pom =  TextHeight(sNazwaDok) *(1+ ( BreakLine ( FRSzer, 1, 1, sNazwaDok) != Len( sNazwaDok ) ))
		print at #X,#Y+(FRwys-pom)/2;sNazwaDok
		PrintMPP(xDocument)
	endif
	if FRid==R_DATAIMIEJSCE then
		SetStyl ( nc )
		print at #X,#Y+10;sDataWyst;"  ";MiejsceWyst;LF
		SetStyl ( sc )
		print od #X,#Y;"data i miejsce wystawienia dokumentu"
	endif
	if FRid==R_NUMER then
			SetStyl ( nc )
			SetFont ( numr )
			y = TextHeight( sNumerDok )
			x = ( FRszer-TextWidth(sNumerDok,numr))/2
			SetStyl ( nl )
			if x<TextWidth("Nr ") then
				print od (FRszer-TextWidth("Nr "))/2,#Y+y-TextHeight("Nr");"Nr";lf
			else
				print od x-TextWidth("Nr "),#Y+y-TextHeight("Nr");"Nr"
			endif
			SetStyl ( nc )
			SetFont ( numr )
			print od 0, #Y;sNumerDok
	endif
	if FRid==R_NAPIS then
		if xDocument.Charakter!=116 && xDocument.Charakter!=118 then
		x = TextWidth(sNapis,grub)
		buf=sNapis
		if find "DUPLIKAT" then
			buf = " "+data()
		else
			buf = ""
		endif
		y = TextWidth(buf,"tekst")
		SetFont(grub)
		print at (FRSzer-x-y)/2,(FRWys-TextHeight(sNapis,grub))/2;sNapis
		SetFont("tekst")
		print at (FRSzer-x-y)/2+x,#Y+(TextHeight(sNapis,grub)-TextHeight(buf,"tekst"));buf
		endif
	endif
#ifdef KOREKTY
	if FRid==R_NRDATAKORYG then
		SetStyl ( nc )
		print at #X, #Y+10; sNrKoryg
		print lf
		SetStyl( sc )
		print od #X, #Y; "numer, data dokumentu korygowanego"
	endif
	If FRid == R_NRDATAKORYG_EXTRA Then
		SetStyl( nc )
		Print At #X , #Y + 10 ; sNrKorygExtra
		Print LF
		SetStyl( sc )
		Print Od #X , #Y ; "numer, data dokumentu korygowanego"
	EndIf
#endif
	if FRid==R_DATAOKRES  then
#ifdef FZALSPKOR
		if bOstatnia then rBoxData.RenameP("Data otrzymania zaliczki", "Okres otrzymania zaliczki")
		rBoxData.PrintGraf(rBoxData.PrepareData(sDataSp), sc, nc, 0, 1, str.Pozycja(#X), str.Pozycja(#Y)+10)
#endif
#ifndef ZALICZKA
		if iTyp != 137 && iTyp != 153 then
			if iTyp == 134 || iTyp == 135 || iTyp == 150 || iTyp == 151 then rBoxData.RenameP("Data realizacji", "Okres realizacji")
			rBoxData.PrintGraf(rBoxData.PrepareData(sDataSp), sc, nc, 0, 1, str.Pozycja(#X), str.Pozycja(#Y)+10)
		endif
#else
		if iTyp != 136 && iTyp != 152 then
			if (!bOstatnia || bZaliczka) then rBoxData.RenameP("Data otrzymania zaliczki", "Okres otrzymania zaliczki")		
		else
			if (bOstatnia) then rBoxData.RenameP("Data otrzymania zaliczki", "Okres otrzymania zaliczki")			
		endif
		rBoxData.PrintGraf(rBoxData.PrepareData(sDataSp), sc, nc, 0, 1, str.Pozycja(#X), str.Pozycja(#Y)+10)
#endif
	endif
	
	if FRid==R_BITMAP then
		bmp = Bitmap nBmpCoord(1),nBmpCoord(2),sBitmap
		Bitmap #bmp, at nBmpCoord(3),nBmpCoord(4)
	endif

	if FRid==R_SPRZEDAWCA then
		if DokZakupu then
			SetStyl ( nl )
			nPom = TextWidth("Sprzedawca: ")+10
			tblIn = tabela 0,5,nPom,nl,FRszer-nPom,nbl
			tabela #tblIn
				kolumna 1,"Sprzedawca: "
				kolumna 2,PiszWyrazy(sNabywca,FRSzer-nPom-10)
			koniec
			nPom = TextWidth("Telefon:")+10
			tblIn = tabela 0,5,nPom,nl,FRszer-nPom,nbl
			tabela #tblIn
				kolumna 1,"Adres:"
				sTMp=sNabKodPocz+" "+sNabMiasto
				if sNabAdres then sTmp+=", "+sNabAdres
				kolumna 2, PiszWyrazy(sTmp,FRszer-nPom-10)
			koniec
			sPom = sNabNip
			if sPom then
				tabela #tblIn
					kolumna 1
					SetFont ( "tekst" ) : print DajNip( sPom )
					kolumna 2
					SetFont ( nb ) : print buf
					if bKonth then SetFont ( "tekst" ) : print "  Kod: " : SetFont ( nb ) : print sNabKod 
				koniec
			endif
			if bKhTeleadr then DrukujKontakt(sNabTel1,sNabTel2,sNabFax,sNabEMail,FRSzer>str.szer/2)
			If bNotatkaKh Then print " "+sNotatkaKontr
		else

			// Tymczasowo nadpisujemy dane sprzedawcy przechowywane w zmiennych
			DaneSprzedawcy tmpSprzedawca
			if CZY_WYSTAWCA Then
	
				tmpSprzedawca.Nazwa 		= sFNazwa
				tmpSprzedawca.KodPocztowy 	= sFkodPocz 
				tmpSprzedawca.Miejscowosc 	= sFMiejsce
				tmpSprzedawca.Adres			= sFAdres 
				tmpSprzedawca.Nip			= sFNip

				sFNazwa		= nSprzedawca.Nazwa
				sFkodPocz	= nSprzedawca.KodPocztowy
				sFMiejsce 	= nSprzedawca.Miejscowosc
				sFAdres 	= nSprzedawca.Adres
				sFNip 		= nSprzedawca.Nip

				sFTel1	= ""
				sFTel2	= ""
				sFFax	= ""
				sFEmail	= ""

			EndIf

			SetStyl ( nl )
			nPom = TextWidth("Sprzedawca: ")+10
			tblIn = tabela 0,5,nPom,nl,FRszer-nPom,nbl
			tabela #tblIn
				kolumna 1,"Sprzedawca: "
					sTmp=sFNazwa
					if len(sFNazwa)>(FRSzer-nPom)/TextWidth("a") then
						sTmp=""
						i=1
						while i < len(sFNazwa)
							sTmp+=mid(sFNazwa,i,(FRSZer-nPom)/TextWidth("a"))+"\n"
							i+=(FRSzer-nPom)/TextWidth("a")
						wend
					endif
					kolumna 2,PiszWyrazy(sFNazwa,FRSzer-nPom-10)
			koniec
			nPom = TextWidth("Telefon:  ")+10
			tblIn = tabela 0,5,nPom,nl,FRszer-nPom,nbl
	
			tabela #tblIn
				kolumna 1,"Adres:"
				sTMp=sFkodPocz+" "+sFMiejsce
				if sFAdres then sTmp+=", "+sFAdres
				kolumna 2, PiszWyrazy(sTmp,FRszer-nPom-10)
			koniec
			sPom = sFNip
			if sPom then
				tabela #tblIn
					kolumna 1
					SetFont ( "tekst" ) : print DajNip( sPom )
					kolumna 2
					SetFont ( nb ) : print buf
				koniec
			endif
			if bDrukBDO == "1" then
				tabela #tblIn
					kolumna 1,"BDO: "
					kolumna 2,sFBDO
				koniec
			endif
			If bFDaneTeleadresowe Then DrukujKontakt(sFTel1,sFTel2,sFFax,sFEmail,0)
			if bFNotatka then print " "+sFNotatka			
		endif


		// Przywracamy do zmiennych prawidowe dane sprzedawcy
		if !DokZakupu then
			if CZY_WYSTAWCA Then
				sFNazwa 	= tmpSprzedawca.Nazwa 
				sFkodPocz 	= tmpSprzedawca.KodPocztowy
				sFMiejsce	= tmpSprzedawca.Miejscowosc
				sFAdres  	= tmpSprzedawca.Adres
				sFNip		= tmpSprzedawca.Nip
			endif
		EndIf

	endif

	if FRid==R_NABYWCA then
 	 	SetStyl ( nl )
		nPom = TextWidth("Nabywca: ")+10
		tblIn = tabela 0,5,nPom,nl,FRSzer-nPom,nbl
		If bNdane Then
			if DokZakupu then
				tabela #tblIn
					kolumna 1,"Nabywca:"
					kolumna 2,sFNazwa
				koniec
				nPom = TextWidth("Telefon:")+10
				tblIn = tabela 0,5,nPom,nl,FRszer-nPom,nbl
					tabela #tblIn
				kolumna 1,"Adres:"
				sTMp=sFkodPocz+" "+sFMiejsce
				if sFAdres then sTmp+=", "+sFAdres
				kolumna 2, PiszWyrazy(sTmp,FRszer-nPom-10)
			koniec
			sPom = sFNip
			if sPom then
				tabela #tblIn
					kolumna 1
					SetFont ( "tekst" ) : print DajNip( sPom )
					kolumna 2
					SetFont ( nb ) : print buf
				koniec
			endif
			if bDrukBDO == "1" then
				tabela #tblIn
					kolumna 1,"BDO: "
					kolumna 2,sFBDO
				koniec
			endif
			else
				tabela #tblIn
					kolumna 1,"Nabywca:"
					kolumna 2,sNabywca
					sTmp=sNabywca
	  	 			SetFont ( nb )
				koniec
				nPom = TextWidth("Telefon:  ")+25
				tblIn = tabela 0,5,nPom,nl,FRSzer-nPom,nbl

					tabela #tblIn
						kolumna 1,"Adres:"
		   				sTmp= sNabKodPocz+" "+sNabMiasto
						if sNabAdres then sTmp+=", "+sNabAdres
						kolumna 2,PiszWyrazy(sTMp,FRSzer-nPom-10)
					koniec

				if sNabNip then
					tabela #tblIn
						kolumna 1
						SetFont ( "tekst" ) : print DajNip(sNabNip)
						kolumna 2
			   			SetFont ( nb ) : print buf;"  "
						if bKonth then SetFont ( "tekst" ) : print "  Kod: " : SetFont ( nb ) : print sNabKod
					koniec
				endif
				if bKonth && !sNabNip then
					tabela #tblIn
						kolumna 1
						SetFont ( "tekst" ) : print " Kod: "
						kolumna 2
						SetFont ( nb ) : print sNabKod
					koniec
				endif
			endif
		Else
			Tabela #tblIn
				Kolumna 1, "Nabywca"
			Koniec
			Tabela #tblIn
				Kolumna 1, DajNip( sNabNip )
				Kolumna 2
					SetFont( nb ) : Print buf
			Koniec
			If bKonth Then
				Tabela #tblIn
					Kolumna 1
						SetFont ( "tekst" ) : Print "Kod: "
					Kolumna 2
						SetFont ( nb ) : Print sNabKod
				Koniec
			EndIf
		EndIf
		if DokZakupu then
			If bFDaneTeleadresowe Then DrukujKontakt(sFTel1,sFTel2,sFFax,sFEmail,0)
			if bFNotatka then print " "+sFNotatka
		else
			if bKhTeleadr then DrukujKontakt(sNabTel1,sNabTel2,sNabFax,sNabEMail,FRSzer>str.szer/2)
			If bNotatkaKh Then print " "+sNotatkaKontr
		endif
	endif

	if FRid==R_DANEPLATNOSCI then
		SetStyl ( nl )
		print " Forma patnoci: "
		SetFont ( nb )
		print sPlatName
		SetFont ( "tekst" )
#ifdef ZAMOWIENIE
		if !bTerminPlat	then
#endif
#ifdef TERMIN
	    if !bOstatnia && (iTyp == 136 || iTyp == 137 || iTyp == 152 || iTyp == 153) then
#endif
			if bOdbiorca then
				print lf;" Termin patnoci: "
			else
				if bPrzelew then
					print "    Termin patnoci: "
				else
					print at FRszer/2,#Y;"Termin patnoci: "
				endif
			endif
			SetFont ( nb )
			print sTerminPlat
#ifdef TERMIN
	   endif
#endif
#ifdef ZAMOWIENIE
		endif
#endif
		SetFont ( "tekst" )
		if  bPrzelew then
			if bOdbiorca then
				print lf;" Bank: "
			else
				print "    Bank: "
			endif
			SetFont ( nb )
			print sNazwaBanku//;" ";sAdresBanku
			SetFont ( "tekst" )
			if bOdbiorca then
				print lf;" Konto: "
			else
				print "   Konto: "
			endif
			SetFont ( nb )
			print sKonto

			if bIsSwift then
				SetFont ( "tekst" )	
				if bOdbiorca then
					print lf;" Swift: "
				else
					print "   Swift: "
				endif
				SetFont ( nb )
				print sSwift
			endif
		endif
#ifdef ZAMWALUTA
	print lf : SetStyl(nl) : print "Waluta: " : SetFont(nb) : print sWaluta
	if bKurs then SetStyl(nl) : print "     Kurs: " : print WstawPrzecinek(fkurs)
#endif

	If iTyp == 150 || iTyp == 151 || iTyp == 152 || iTyp == 153 Then
		Print lf : SetStyl( nl ) : Print " Waluta: " : SetFont( nb ) : Print sWaluta
		If PKurs Then
			SetStyl( nl )
			If iTyp == 150 || iTyp == 151 Then
				Print "     Kurs: "
			Else
				Print "     Kurs VAT: "
			EndIf
			Print WstawPrzecinek( fkurs )
		EndIf
		If PKursDoch && ( iTyp == 152 || iTyp == 153 ) Then
			SetStyl( nl ) : Print "     Kurs CIT/PIT: " : Print WstawPrzecinek( fkursDoch )
		EndIf
	EndIf

	endif

	if FRid==R_ODBIORCA  then
		SetStyl ( nl )
		if DokZakupu then
			nPom = TextWidth ( "Dostawca: " )+10
		else
			nPom = TextWidth ( "Odbiorca: " )+10
		endif
		tblIn = tabela 0,5,nPom,nl,FRszer-nPom,nbl
		tabela #tblIn
		if DokZakupu then
			kolumna 1,"Dostawca: "
		else
			kolumna 1,"Odbiorca: "
		endif
			kolumna 2,sOdbiorca
		koniec
		tabela #tblIn
			kolumna 1,"Adres: "
			kolumna 2
			print sOdbKodPocz;" ";sOdbMiasto
			if sOdbAdres then print ", ";sOdbAdres
		koniec
	endif
	
	if FRid==R_DOZAPLATYW  || FRid==R_DOZAPLATYN then
	 	SetStyl(nbl)
        #ifdef ZALICZKASP
	    if xDocument.Wartosc >= 0 then
    	    print at 30,10+10*(FRid==R_DOZAPLATYN);"Razem do zapaty: "
        else
            print at 30,10+10*(FRid==R_DOZAPLATYN);"Razem do zwrotu: "
        endif
        #else
	 	    print at 30,10+10*(FRid==R_DOZAPLATYN);"Razem do zapaty: "
        #endif
	 	SetFont(grub)
		Select case xDocType
			case 101,150,151,152,153
				print kwota(xDocument.WartoscWWalucie) + " "+sWaluta //dok exp w walucie
			case 103
				print kwota(rWartosci.wwalucie) + " "+sWaluta
			case 138
				print kwota(xDocument.rzeczywistaWysokoscNaleznosci)+ " " +sWaluta
			case else
		        #ifdef ZALICZKASP
			    if (xDocument.rzeczywistaWysokoscNaleznosci) >= 0 then
		    	    print kwota(xDocument.rzeczywistaWysokoscNaleznosci)+sPLN
		        else
		            print kwota(-(xDocument.rzeczywistaWysokoscNaleznosci) )+sPLN
		        endif
		        #else
			    	print kwota(xDocument.rzeczywistaWysokoscNaleznosci)+sPLN
		        #endif
		endselect
	endif

	if FRid==R_ZAPLACONO then
		print at 0,30;
		SetStyl(nl)
		SetFont("tekst")
        #ifdef ZALICZKASP
	     if xDocument.Wartosc < 0 then 	fDoZaplaty = -fDoZaplaty
	    #endif
		 if (CzyRozrWal && Sign(fDoZaplatyWal-fWplatyWal,2)) || (!CzyRozrWal && Sign(fDoZaplaty-fWplaty,2)) then
			if fWplaty then
			    #ifdef ZALICZKASP
				    if xDocument.Wartosc >= 0 then
			    	    print "Zapacono: "
			        else
			            print "Zwrcono: "
			        endif
		        #else
				    print "Zapacono: "
                #endif
				SetFont(nb)
				if xDocType==101 || xDocType==150 || xDocType==151 || xDocType==152 || xDocType==153 then
					print kwota(fWplatyWal) + " "+sWaluta;
				else
					print kwota(fWplaty)+sPLN;
				endif
				SetStyl(nl)
				print "     "
			endif
		    #ifdef ZALICZKASP
			    if xDocument.Wartosc >= 0 then
		    	    print "Pozostao do zapaty: "
		        else
		            print "Pozostao do zwrotu: "
		        endif
	        #else
    			print "Pozostao do zapaty: "
            #endif
			SetFont(nb)
			if xDocType==101 || xDocType == 138 || xDocType==150 || xDocType==151 || xDocType==152 || xDocType==153 then
				print kwota(round(xDocument.WartoscWWalucie,2)-fWplatyWal) + " " +sWaluta
			else
		        #ifdef ZALICZKASP
			       if xDocument.rzeczywistaWysokoscNaleznosci < 0 then 	
	                  print kwota(-xDocument.rzeczywistaWysokoscNaleznosci)+sPLN
                   else
                      print kwota(round(xDocument.rzeczywistaWysokoscNaleznosci,2)-fWplaty)+sPLN
                   endif
		        #else
				   print kwota(IIF(CZyRozrWal,(round(xDocument.WartoscWWalucie,2)-fWplatyWal)*fKurs,round(xDocument.rzeczywistaWysokoscNaleznosci ,2)-fWplaty))+sPLN
	   			#endif
			endif
		else
			SetFont(grub)
		    #ifdef ZALICZKASP
			    if xDocument.Wartosc >= 0 then
		    	   	print "ZAPACONO"
		        else
		           	print "ZWRCONO"
		        endif
	        #else
    			print "ZAPACONO"
            #endif
		endif
	endif

	if FRid==R_UPOWAZW || FRid==R_UPOWAZN  then		// 14-wysze 15-nisze
		x=(FRSzer-1400)/4
		nPom = tabela 0,0,x,nl,700,nl,2*x,nl,700,nl
		tabela #nPom, at 0,0
			kolumna 2
			buf = Arg5 : sPom="sc2"
			if find regular "=-(^u$)|(upowa?nienie)" then
				buf="Dokument wystawiony na podstawie pisemnego upowanienia kupujcego"
			else
				if !buf then
					buf="nazwisko i podpis osoby upowanionej do odebrania dokumentu"
				else
					buf="Odebra(a): "+buf : sPom="sc3"
				endif
			endif
		 	SetStyl ( sPom )
			print at #X,#Y+210-80*(FRid==R_UPOWAZN );buf
			kolumna 4
			buf="nazwisko i podpis osoby upowanionej do\nwystawienia dokumentu"	: sPom="sc2"
			if Arg4 then buf="Wystawi(a): "+Arg4 : sPom="sc3"
	 		SetStyl ( sPom )
			print at #X,#Y+210-80*(FRid==R_UPOWAZN );buf
		koniec
		y=str.pozycja(#B)-str.pozycja(#T)
		if bRamki then
			DrawLine at x,0,700,0,1 : DrawLine at x,y,700,0,1
			DrawLine at x,0,0,y,1 : DrawLine at x+700,0,0,y,1
			x=x*3+700
			DrawLine at x,0,700,0,1 : DrawLine at x,y,700,0,1
			DrawLine at x,0,0,y,1 : DrawLine at x+700,0,0,y,1
		endif
	endif
#ifdef ZAMOWIENIE
	if bTerminPlat then
#endif
	if FRid==R_TERMINREAL then
   	SetStyl(nc)
 		print at #X,#Y+10;sTerminPlat;lf
		SetStyl(sc)
 		print at #X,#Y;"termin realizacji"
 	endif
#ifdef ZAMOWIENIE
	endif
#endif
	if FRid==R_ZALOTRZYMANO then
		buf="ZALICZKA otrzymano dnia "+sDataSp
		y = TextWidth(buf,"tekst")
		SetFont("tekst")
		print at (FRSzer-y)/2,#Y+(TextHeight(buf,"tekst"));buf
	endif

	if FRid==R_ZALNIEOBEJETE then
		buf="NIE OBJTE FAKTURAMI ZALICZKOWYMI"
		y = TextWidth(buf,"tekst")
		SetFont("tekst")
		print at (FRSzer-y)/2,#Y+(TextHeight(buf,"tekst"));buf
	endif

	If FRid == R_DOKNIEFAKT Then
		SetFont( "tekst" )
		buf = "Niniejszy dokument nie jest faktur w rozumieniu Ustawy z dnia 11 marca 2004 r."
		y = TextWidth( buf, "tekst" )
		pom =  ( FRwys - 2 * TextHeight( buf ) ) / 2
		Print At ( FRSzer - y ) / 2, #Y + pom; buf
		buf = "o podatku od towarw i usug (Dz. U. 2004 nr 54 poz. 535)."
		y = TextWidth( buf, "tekst" )
		Print At ( FRSzer - y ) / 2, #Y + ( TextHeight( buf, "tekst" ) ); buf
	endif

	If FRid == R_WTYMVAT Then
	 	SetStyl( nbl )
	 	Print At 30, 20; "W tym VAT: "
	 	SetFont( grub )
		Print Kwota( xDocument.Vat ) + " PLN"
	EndIf

if FRid==R_WYSTAWCA Then

			SetStyl ( nl )
			nPom = TextWidth("Wystawca: ")+10
			tblIn = tabela 0,5,nPom,nl,FRszer-nPom,nbl
			tabela #tblIn
				kolumna 1,"Wystawca: "
					sTmp=sFNazwa
					if len(sFNazwa)>(FRSzer-nPom)/TextWidth("a") then
						sTmp=""
						i=1
						while i < len(sFNazwa)
							sTmp+=mid(sFNazwa,i,(FRSZer-nPom)/TextWidth("a"))+"\n"
							i+=(FRSzer-nPom)/TextWidth("a")
						wend
					endif
					kolumna 2,PiszWyrazy(sFNazwa,FRSzer-nPom-10)
			koniec
			nPom = TextWidth("Telefon:  ")+10
			tblIn = tabela 0,5,nPom,nl,FRszer-nPom,nbl
	
			tabela #tblIn
				kolumna 1,"Adres:"
				sTMp=sFkodPocz+" "+sFMiejsce
				if sFAdres then sTmp+=", "+sFAdres
				kolumna 2, PiszWyrazy(sTmp,FRszer-nPom-10)
			koniec
//			sPom = sFNip
//			if sPom then
//				tabela #tblIn
//					kolumna 1
//					SetFont ( "tekst" ) : print DajNip( sPom )
//					kolumna 2
//					SetFont ( nb ) : print buf
//				koniec
//			endif

			If bFDaneTeleadresowe Then DrukujKontakt(sFTel1,sFTel2,sFFax,sFEmail,0)
endif

if FRid==R_DANEPLATNOSCI_WYST Then
	SetStyl ( nl )
		print " Forma patnoci: "
		SetFont ( nb )
		print sPlatName
		SetFont ( "tekst" )
#ifdef ZAMOWIENIE
		if !bTerminPlat	then
#endif
#ifdef TERMIN
	    if !bOstatnia && (iTyp == 136 || iTyp == 137 || iTyp == 152 || iTyp == 153) then
#endif
			if bOdbiorcaWyst then
				print lf;" Termin patnoci: "
			else
				if bPrzelew then
					print "    Termin patnoci: "
				else
					print at FRszer/2,#Y;"Termin patnoci: "
				endif
			endif
			SetFont ( nb )
			print sTerminPlat
#ifdef TERMIN
	   endif
#endif
#ifdef ZAMOWIENIE
		endif
#endif
		SetFont ( "tekst" )
		if  bPrzelew then
			if bOdbiorcaWyst then
				print lf;" Bank: "
			else
				print "    Bank: "
			endif
			SetFont ( nb )
			print sNazwaBanku//;" ";sAdresBanku
			SetFont ( "tekst" )
			if bOdbiorcaWyst then
				print lf;" Konto: "
			else
				print "   Konto: "
			endif
			SetFont ( nb )
			print sKonto

			if bIsSwift then
				SetFont ( "tekst" )	
				if bOdbiorcaWyst then
					print lf;" Swift: "
				else
					print "   Swift: "
				endif
				SetFont ( nb )
				print sSwift
			endif
		endif
#ifdef ZAMWALUTA
	print lf : SetStyl(nl) : print "Waluta: " : SetFont(nb) : print sWaluta
	if bKurs then SetStyl(nl) : print "     Kurs: " : print WstawPrzecinek(fkurs)
#endif

	If iTyp == 150 || iTyp == 151 || iTyp == 152 || iTyp == 153 Then
		Print lf : SetStyl( nl ) : Print " Waluta: " : SetFont( nb ) : Print sWaluta
		If PKurs Then
			SetStyl( nl )
			If iTyp == 150 || iTyp == 151 Then
				Print "     Kurs: "
			Else
				Print "     Kurs VAT: "
			EndIf
			Print WstawPrzecinek( fkurs )
		EndIf
		If PKursDoch && ( iTyp == 152 || iTyp == 153 ) Then
			SetStyl( nl ) : Print "     Kurs CIT/PIT: " : Print WstawPrzecinek( fkursDoch )
		EndIf
	EndIf

endif

endsub


//obsuga formatowania ramki przy dwch rodzajach styli
int szerRamki
int poczRamki
int istniejeRamka
int sub UstawRamke(int x,int y,int dx,int dy,int gRamki,int mainStyl)
	if istniejeRamka==1 then error "Nie zakoczono ramki"
	ramka od x,y,dx,dy,gRamki
	szerRamki=x+dx
	poczRamki=x
	SetStyl(mainStyl)
	print at 0,20;" "
	istniejeRamka=1
endsub

int sub ZakonczRamke()
	if istniejeRamka!=1 then error "Nie ustawiono ramki"
	istniejeRamka=0
	koniec
endsub


int sub DrukujWRamce(int styl1,string value1,int styl2,string value2)
int tw
if istniejeRamka!=1 then error "Nie ustawiono ramki"

	SetStyl(styl1)
	tw = TextWidth(value1+" ")
	SetStyl(styl2)
	tw+=TextWidth(value2+" ")

	SetStyl(styl1)
		if(str.pozycja(#X)+tw>szerRamki) then	print lf;" ";
		print value1+" "

	SetStyl(styl2)
		print value2+" "

endsub
#include "Dokument sprzeday - ramki 2"
#ifdef PLATWYD
int Sub Notatka()
	sNotatka=formatNotatka(sNotatka)
	if GRAF then
		if bNotat && sNotatka then
			MultiPagePrint( sNotatka, 0, Str.Pozycja( #Y ) + 20, Str.Szer, 10, bRamki, nl )
		endif
		if arg6 != "" then
			ramka od 0, #y+20, str.szer, 10
				SetFont ( "tekst" ) : Align(-1)
				print arg6
			koniec
		endif
	else
	    SetStyl( l12 )
		if bNotat && sNotatka then 
		print "\n\n"
		MultiPagePrint( sNotatka, 0, Str.Pozycja( #Y ) + 20, Str.Szer, 10, 0, l12 )
		endif
		if arg6 then print "\n\n UWAGA: ";arg6;lf
	endif
EndSub

int Sub NotatkaRodz()
	sNotatkaRodz=formatNotatka(sNotatkaRodz)
	if GRAF then
		if bNotatRodz && sNotatkaRodz then
			MultiPagePrint( sNotatkaRodz, 0, Str.Pozycja( #Y ) + 20, Str.Szer, 10, bRamki, nl )
		endif
	else
	    SetStyl( l12 )
		if bNotatRodz && sNotatkaRodz then 
	    print "\n\n"
        MultiPagePrint( sNotatkaRodz, 0, Str.Pozycja( #Y ) + 20, Str.Szer, 10, 0, l12 )
    endif
	endif
EndSub
#endif

#ifdef DEKRET
int Sub Dekretacje()
string sWN, sKwota, sMA, sKw, sKnt
int i
string sDekret
sDekret = IIF(DokZakupu, "BDekretacjeZk", "BDekretacjeSp")
	
dispatch xDekretacje=xFactory.NewObject(sDekret)
dispatch xDekretParams=xFactory.NewObject("BDekretParams")

	xDekretParams.id=xDocument.id
	xDekretacje.Dekret(xDekretParams)
	
	if iTyp==FWS then
	  sNapis = arg9
    endif

	swap buf, sNapis

	if bDekretacje && ((find "KOPIA") != "")  then
		y = str.Pozycja(#B)+50
		tbl2 = tabela 1,4004, 300,bc,250,bc,300,bc
		if GRAF then
			ramka od 0,y,850,10,0,nGray
		else
			print "\n"
			ramka od 0,#Y,str.szer,10,0
		endif
			tabela #tbl2, od 0,0
				kolumna 1, "WN"
				kolumna 2, "Kwota"
				kolumna 3, "MA"
			koniec
		koniec
		tbl2 = tabela 1,4004, 300,nc,250,kr,300,nc
		for i=1 to i>xDekretacje.Zapisy.Count()
			if xDekretacje.Zapisy.item(i).ma then
				sMa+=xDekretacje.Zapisy.item(i).konto+"\n"
				sWN+="\n"
			else
				sMa+="\n"
				sWN+=xDekretacje.Zapisy.item(i).konto+"\n"
			endif
			Buf = using "%.2f\n",xDekretacje.Zapisy.item(i).kwota
			Replace ".", ","
			sKwota+=Buf
			if i==xDekretacje.zapisy.Count() || (i<xDekretacje.zapisy.Count() && xDEkretacje.zapisy.item(i).lp!=xDekretacje.zapisy.item(i+1).lp) then
				ramka od 0,#Y,str.szer,10,0
					tabela #tbl2, od 0,0
						kolumna 2, sKwota
							sKwota = ""
						kolumna 1, sWN
							sWN = ""
						kolumna 3, sMA
							sMA = ""
					koniec
				koniec
			endif
		next i
	endif

	Swap buf,sNapis

EndSub
#endif

Int Sub ProFormaInfo()
	String sTmp = buf	
	buf = UCase( Arg9 )
	// Tylko dla "Pro forma" z bufora
	If Arg2 == "1" && Arg3 == "2" && Find Regular ":b*PRO:b*FORMA:b*" Then
		Print At 0, Str.Pozycja( #Y ) + 50;
		FRNewRow( 0 )
		FRAddCol( -100, 100, R_DOKNIEFAKT, bRamki, 0 )
		FRDraw()
	EndIf
	buf = sTmp
EndSub