﻿
ALTER PROCEDURE HM.hm_QueryPozycjeKorektyMZ

@superkoryg int,
@super int
AS

  select MZ.id, MZ.flag, MZ.subtyp, MZ.typ, MZ.super, MZ.lp, MZ.idkh, MZ.idtw, MZ.kod, MZ.data,
         MZ.opis, MZ.opisdod, MZ.ilosc, MZ.jm, MZ.grupacen, MZ.cena, MZ.wartNetto, MZ.idpozkoryg,
         MZ.rejestr, MZ.idlongname, MZ.magazyn, MZ.iloscjedn, MZ.iloscwp,
         MZ.przychod, MZ.rozchod, MZ.wartk, MZ.lwartk, MZ.schemat, MZ.jmwp, MZ.bufor,
         MZ.kompensata, MZ.superkoryg, MZ.iloscRLKS, tx.opis as opisTX, ISNULL(uz.kodobcy, '') AS kodobcy
  from MZ
  left outer join tx on tx.id = MZ.idlongname
  left outer join uz on uz.iduz = MZ.idtw and uz.idkh = MZ.idkh and uz.typ = 32 and MZ.idtw IS NOT NULL and MZ.idkh IS NOT NULL
    join (select lp, kompensata, MAX(MZ.super) AS super, MAX(map.sId) AS superS
      from MZ LEFT OUTER JOIN HM._MapMgDoc AS map ON MZ.super = map.eId AND map.sId <> map.eId
      where MZ.superkoryg = @superkoryg
            and (MZ.flag & 0x2000) = 0
            and (MZ.super = @super OR (MZ.super < @super and MZ.kompensata = 0))
      group by MZ.lp, MZ.kompensata) AS MZ2
    on MZ.lp = MZ2.lp and
       MZ.kompensata = MZ2.kompensata and
       MZ.super = CASE WHEN MZ2.superS IS NULL THEN MZ2.super
                       ELSE ISNULL((SELECT MAX(eId) FROM HM._MapMgDoc WHERE sId = MZ2.superS AND eId = @super),
                                   (SELECT TOP 1 MG.id
                                      FROM HM.MG
                                           INNER JOIN HM.MZ ON MG.id = MZ.super
                                           LEFT OUTER JOIN HM._MapMgDoc AS map ON MG.id = map.eId
                                     WHERE MG.iddokkoryg = @superkoryg AND (MZ.super = @super OR (MZ.super < @super AND MZ.kompensata = 0))
                                     ORDER BY ISNULL(map.sId, 2147483647) DESC, MG.id DESC
                                   )
                                  )
                  END
  order by MZ.lp, MZ.kompensata
