﻿ALTER PROCEDURE HM.hm_RZ_PrzydzielDostawyMKP
@idpoz int
as







declare @tblPWM TABLE
  (id int, iddw int, iddwo int, ilosc decimal(24,6), wartosc decimal(24,2))

declare @tblPWR TABLE
  (id int, iddw int, iddwo int, used smallint, ilosc decimal(24,6), wartosc decimal(24,2))

declare @tblPWRR TABLE
  (id int, delta decimal(24,2))

declare @tblDWS TABLE
  (id int, ilosc decimal(24,6), wartosc decimal(24,2))

declare @idmm int, @idrez int, @iddwp int, @iddwo int, @idtw int, @mg int
declare @bazamg int, @bazamz int
declare @termin int
declare @ilosc decimal(24,6), @iloscrz decimal(24,6), @stanhandl decimal(24,6), @ildw decimal(24,6)
declare @wartosc decimal(24,2), @wartoscrz decimal(24,2), @wartdw decimal(24,2)
declare @wdostawe smallint, @insrez smallint, @delrez smallint
declare @return_status int

set @bazamg = 33
set @bazamz = 37
set @termin = 7


declare @tblZZM TABLE (id int primary key, id1 int, id2 int)

insert @tblZZM
select ZZ.id, ZZ.id1, ZZ.id2 from ZZ join MZ on MZ.super = ZZ.id1 where ZZ.typ = 114 and ZZ.baza2 = 33 and MZ.id = @idpoz


select @idmm = MZM.id
from @tblZZM as ZZM join MZ as MZM on MZM.super = ZZM.id2 join MZ as MZP on MZP.super = ZZM.id1
where MZM.lp = MZP.lp and MZM.kompensata = 0 and MZP.kompensata = 0 and MZP.id = @idpoz

insert @tblPWM
select PW.id, PW.iddw, DWM.iddwo, PW.ilosc, PW.wartosc + ISNULL(PWK.wartosc, 0.0)
from PW join (select DW.id, ISNULL(DW.iddw, DW.id) as iddwo from DW) as DWM on DWM.id = PW.iddw
left join (select SUM(PW.wartosc) as wartosc, PW.idkoryg from PW where PW.typ = 37 group by PW.idkoryg) as PWK on PWK.idkoryg = PW.id
where PW.typ = 37 and PW.idmg = @idmm




select @idtw = MZ.idtw, @mg = MZ.magazyn, @wdostawe = case when (MZ.flag & 0x0800) = 0 then 0 else 1 end,
       @idrez = ISNULL(RZ.id, 0), @iloscrz = ISNULL(RZ.iloscrz, 0.0)
from MZ join TW on MZ.idtw = TW.id
left join RZ on (RZ.bazapozrz = @bazamz and RZ.idpozrz = @idpoz and MZ.idtw = RZ.idtw and MZ.magazyn = RZ.magazyn)
where MZ.id = @idpoz



if @idrez = 0
 begin

  set @insrez = 0
  if @wdostawe = 0
   begin
    select @ilosc = ISNULL(SUM(PWM.ilosc), 0.0) from @tblPWM as PWM
    if @ilosc < 0.0
     set @insrez = 1
   end
  else
   begin
    if exists (select * from @tblPWM where ilosc < 0.0)
     set @insrez = 1
   end

  if @insrez <> 0
   begin


    insert into RZ (flag, subtyp, typ, idtw, idkh, magazyn, data, termin, iloscrz, iloscrl, wartosc, iddokrz, bazadokrz, idpozrz, bazapozrz)
    select 0, 0, 2, MZ.idtw, MZ.idkh, MZ.magazyn, MZ.data, MZ.data + @termin, 0.0, 0, 0.0, MZ.super, @bazamg, @idpoz, @bazamz
    from MZ join MZ as MZK on MZ.super = MZK.super and MZ.lp = MZK.lp and MZK.kompensata = 1
    where MZ.id = @idpoz
    select @return_status = @@error, @idrez = SCOPE_IDENTITY()
    if @return_status <> 0 return @return_status
   end

 end
else
 begin

  set @delrez = 0
  if @wdostawe = 0
   begin
    select @ilosc = ISNULL(SUM(PWM.ilosc), 0.0) from @tblPWM as PWM
    if @ilosc > 0.0
     set @delrez = 1
   end
  else
   begin
    if not exists (select * from @tblPWM where ilosc < 0.0)
     set @delrez = 1
   end

  if @delrez <> 0
   begin

    exec @return_status = hm_RZ_UsunRezerwacje @idrez
    return @return_status
   end

 end

if @wdostawe = 0
 begin

  insert @tblPWR
  select PW.id, PW.iddw, 0, 0, PW.ilosc, PW.wartosc
  from PW where PW.typ = 26 and PW.idmg = @idrez


  select @ilosc = SUM(PWM.ilosc) from @tblPWM as PWM
  select @wartosc = SUM(PWM.wartosc) from @tblPWM as PWM --analogicznie jak ilość, wartosc bierzemy z mk- bo musi być zgodna z drugą mm-ką

  if @ilosc < 0.0
   begin

    set @iddwp = 0
    select distinct @iddwp = PW.iddw
    from MZ join MZ as MZK on MZ.superkoryg = MZK.superkoryg and MZ.lp = MZK.lp
    join PW on PW.typ = 37 and PW.idmg = MZK.id where MZ.id = @idpoz


    if @iddwp = 0
      return -1

	select @ildw = iloscdosp, @wartdw = wartoscdosp from DW where DW.id = @iddwp
	--set @wartosc = 0.0
	--if @ildw <> 0.0
	--  set @wartosc = @wartdw / @ildw * @ilosc


    if exists (select * from @tblPWR where iddw = @iddwp)
     update @tblPWR
     set ilosc = -@ilosc, wartosc = -@wartosc, used = 1
     from @tblPWR as PWR where PWR.iddw = @iddwp
    else
     insert @tblPWR
     select 0, @iddwp, 0, 1, -@ilosc, -@wartosc
   end
 end
else
 begin

  insert @tblPWR
  select PW.id, PW.iddw, DWM.iddwo, 0, PW.ilosc, PW.wartosc
  from PW join (select DW.id, ISNULL(DW.iddw, DW.id) as iddwo from DW) as DWM on DWM.id = PW.iddw
  where PW.typ = 26 and PW.idmg = @idrez

  if exists (select * from @tblPWM where ilosc < 0.0)
   begin


    update @tblPWR
    set ilosc = -PWM.ilosc, wartosc = -PWM.wartosc, used = 1
    from @tblPWM as PWM join @tblPWR as PWR on PWR.iddwo = PWM.iddwo and PWM.ilosc < 0.0


    insert @tblPWR
    select 0, DWP.id, PWM.iddwo, 1, -PWM.ilosc, -PWM.wartosc
    from @tblPWM as PWM left join @tblPWR as PWR on PWR.iddwo = PWM.iddwo
    join (select DW.id, ISNULL(DW.iddw, DW.id) as iddwo from DW join MZ as MZP on DW.idtw = MZP.idtw and DW.magazyn = MZP.magazyn where DW.numer > 0 and MZP.id = @idpoz) as DWP on DWP.iddwo = PWM.iddwo
    where PWM.ilosc < 0.0 and PWR.id is NULL
   end
 end



if @idrez <> 0
 begin
  delete from PW where PW.id in (select PWR.id from @tblPWR as PWR where PWR.used = 0)
  set @return_status = @@error
  if @return_status <> 0 return @return_status

  update PW
  set PW.ilosc = PWR.ilosc, PW.wartosc = PWR.wartosc
  from PW with (ROWLOCK)
  join @tblPWR as PWR on PW.id = PWR.id where PWR.used = 1
  set @return_status = @@error
  if @return_status <> 0 return @return_status


  insert into PW
  select 0, 0, 26, NULL, @idrez, DW.id, RZ.idtw, PWR.ilosc, PWR.wartosc, 0.0, PWK.idkoryg, RZ.data
  from RZ, @tblPWR as PWR join DW on PWR.iddw = DW.id
  left join
   (select MIN(PW.id) as idkoryg, PW.iddw
    from MZ join MZ as MZK on MZ.superkoryg = MZK.superkoryg and MZ.lp = MZK.lp
    join PW on PW.typ = 37 and PW.idmg = MZK.id join DW on DW.id = PW.iddw
    where MZ.id = @idpoz group by PW.iddw) as PWK on PWK.iddw = PWR.iddw
  where RZ.id = @idrez and PWR.used = 1 and PWR.id = 0
  set @return_status = @@error
  if @return_status <> 0 return @return_status


  insert @tblDWS
  select PW.iddw, -SUM(PW.ilosc), -SUM(PW.wartosc)
  from PW join @tblPWR as PWR on PW.iddw = PWR.iddw
  where PW.typ <> 39 group by PW.iddw

  if exists (select * from @tblDWS where ilosc < 0.0)

    return -4900

  if exists (select * from @tblDWS where ilosc = 0.0 and wartosc <> 0.0)
   begin

	insert @tblPWRR
	select PW.id, PW.wartosc - DWS.wartosc
    from PW join @tblDWS as DWS on PW.iddw = DWS.id
    where PW.typ = 26 and PW.idmg = @idrez and DWS.ilosc = 0.0 and DWS.wartosc <> 0.0

    update PW
    set PW.wartosc = case when PWRR.delta < 0.0 then 0.0 else PWRR.delta end
    from PW with (ROWLOCK)
    join @tblPWRR as PWRR on PW.id = PWRR.id
    set @return_status = @@error
    if @return_status <> 0 return @return_status


    update @tblDWS set wartosc = cast( PWS.wartosc as decimal(24,2) )
    from @tblDWS as DWS join
    (select PW.iddw, -SUM(PW.wartosc) as wartosc
     from PW join @tblPWR as PWR on PW.iddw = PWR.iddw
     where PW.typ <> 39 group by PW.iddw) as PWS on PWS.iddw = DWS.id
   end


  update DW set iloscdosp = DWS.ilosc, wartoscdosp = DWS.wartosc from DW join @tblDWS as DWS on DW.id = DWS.id
  set @return_status = @@error
  if @return_status <> 0 return @return_status


  select @stanhandl = SUM(DW.iloscdosp) from DW with (INDEX(IDX_DW_IDTW_MAGAZYN_BUFOR))  where bufor = 0 and idtw = @idtw and magazyn = @mg
  if @stanhandl < 0.0

    return -4701

  update SM set stanHandl = @stanhandl where idtw = @idtw and magazyn = @mg
  set @return_status = @@error
  if @return_status <> 0 return @return_status


  select @iloscrz = ISNULL(SUM(PW.ilosc), 0.0), @wartoscrz = ISNULL(SUM(PW.wartosc), 0.0)
  from PW where PW.typ = 26 and PW.idmg = @idrez


  update RZ set iloscrz = @iloscrz, wartosc = @wartoscrz where RZ.id = @idrez
  set @return_status = @@error
  if @return_status <> 0 return @return_status

  insert LOCAL_LOG (baseName, rec_id,operation,term) VALUES ('RZ', @idrez, 3, @@SPID)

 end

